//
// This file was generated by the JavaTM Architecture for XML Binding(JAXB) Reference Implementation, vhudson-jaxb-ri-2.1-2 
// See <a href="http://java.sun.com/xml/jaxb">http://java.sun.com/xml/jaxb</a> 
// Any modifications to this file will be lost upon recompilation of the source schema. 
// Generated on: 2020.05.12 at 05:13:24 PM CEST 
//


package se.arbetsformedlingen.matchning.portability.dto;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.databind.annotation.JsonDeserialize;
import com.fasterxml.jackson.databind.annotation.JsonSerialize;

import javax.xml.bind.annotation.XmlAccessType;
import javax.xml.bind.annotation.XmlAccessorType;
import javax.xml.bind.annotation.XmlElement;
import javax.xml.bind.annotation.XmlType;
import java.util.ArrayList;
import java.util.List;


@XmlAccessorType(XmlAccessType.FIELD)
@XmlType(name = "LicenseType", propOrder = {

})
@JsonInclude(JsonInclude.Include.NON_NULL)
public class LicenseType {

    public IdentifierType id;
    public String name;
    @JsonIgnore
    public EntityType type;
    public String status;
    public EffectiveTimePeriodType effectiveTimePeriod;
    @JsonSerialize(using = DateType.DateTypeSerializer.class)
    @JsonDeserialize(using = DateType.DateTypeDeserializer.class)
    public DateType issued;
    public String firstIssued;
    public OrganizationType issuingAuthority;
    @JsonIgnore
    public List<AttachmentReferenceType> attachmentReferences;
    @JsonIgnore
    public List<String> descriptions;
    public List<Endorsements.Item> endorsements;
    public List<Restrictions.Item> restrictions;
    public List<Violations.Item> violations;

    public IdentifierType getId() {
        return id;
    }

    public void setId(final IdentifierType id) {
        this.id = id;
    }

    public String getName() {
        return name;
    }

    public void setName(final String name) {
        this.name = name;
    }

    public EntityType getType() {
        return type;
    }

    public void setType(final EntityType type) {
        this.type = type;
    }

    public String getStatus() {
        return status;
    }

    public void setStatus(final String status) {
        this.status = status;
    }

    public EffectiveTimePeriodType getEffectiveTimePeriod() {
        return effectiveTimePeriod;
    }

    public void setEffectiveTimePeriod(final EffectiveTimePeriodType effectiveTimePeriod) {
        this.effectiveTimePeriod = effectiveTimePeriod;
    }

    public DateType getIssued() {
        return issued;
    }

    public void setIssued(final DateType issued) {
        this.issued = issued;
    }

    public String getFirstIssued() {
        return firstIssued;
    }

    public void setFirstIssued(final String firstIssued) {
        this.firstIssued = firstIssued;
    }

    public OrganizationType getIssuingAuthority() {
        return issuingAuthority;
    }

    public void setIssuingAuthority(final OrganizationType issuingAuthority) {
        this.issuingAuthority = issuingAuthority;
    }

    public List<AttachmentReferenceType> getAttachmentReferences() {
        if (attachmentReferences == null) {
            attachmentReferences = new ArrayList<AttachmentReferenceType>();
        }
        return this.attachmentReferences;
    }

    public void setAttachmentReferences(final List<AttachmentReferenceType> attachmentReferences) {
        this.attachmentReferences = attachmentReferences;
    }

    public List<String> getDescriptions() {
        if (descriptions == null) {
            descriptions = new ArrayList<String>();
        }
        return this.descriptions;
    }

    public void setDescriptions(final List<String> descriptions) {
        this.descriptions = descriptions;
    }

    public List<Endorsements.Item> getEndorsements() {
        return endorsements;
    }

    public void setEndorsements(final List<Endorsements.Item> endorsements) {
        this.endorsements = endorsements;
    }

    public List<Restrictions.Item> getRestrictions() {
        return restrictions;
    }

    public void setRestrictions(final List<Restrictions.Item> restrictions) {
        this.restrictions = restrictions;
    }

    public List<Violations.Item> getViolations() {
        return violations;
    }

    public void setViolations(final List<Violations.Item> violations) {
        this.violations = violations;
    }

    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
            "item"
    })
    public static class Endorsements {

        @XmlElement(required = true)
        protected List<Item> item;


        public List<Item> getItem() {
            if (item == null) {
                item = new ArrayList<Item>();
            }
            return this.item;
        }

        @XmlAccessorType(XmlAccessType.FIELD)
        @XmlType(name = "", propOrder = {

        })
        public static class Item {

            @JsonSerialize(using = DateTimeType.DateTypeSerializer.class)
            @JsonDeserialize(using = DateTimeType.DateTypeDeserializer.class)
            protected DateTimeType validFrom;
            @JsonSerialize(using = DateTimeType.DateTypeSerializer.class)
            @JsonDeserialize(using = DateTimeType.DateTypeDeserializer.class)
            protected DateTimeType validTo;
            @XmlElement(required = true)
            protected String value;
            protected String description;

            public DateTimeType getValidFrom() {
                return validFrom;
            }

            public void setValidFrom(final DateTimeType validFrom) {
                this.validFrom = validFrom;
            }

            public DateTimeType getValidTo() {
                return validTo;
            }

            public void setValidTo(final DateTimeType validTo) {
                this.validTo = validTo;
            }

            public String getValue() {
                return value;
            }

            public void setValue(final String value) {
                this.value = value;
            }

            public String getDescription() {
                return description;
            }

            public void setDescription(final String description) {
                this.description = description;
            }
        }

    }


    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
            "item"
    })
    public static class Restrictions {

        @XmlElement(required = true)
        protected List<Item> item;

        public List<Item> getItem() {
            if (item == null) {
                item = new ArrayList<Item>();
            }
            return this.item;
        }


        @XmlAccessorType(XmlAccessType.FIELD)
        @XmlType(name = "", propOrder = {

        })
        public static class Item {

            @JsonSerialize(using = DateTimeType.DateTypeSerializer.class)
            @JsonDeserialize(using = DateTimeType.DateTypeDeserializer.class)
            protected DateTimeType validFrom;
            @JsonSerialize(using = DateTimeType.DateTypeSerializer.class)
            @JsonDeserialize(using = DateTimeType.DateTypeDeserializer.class)
            protected DateTimeType validTo;
            @XmlElement(required = true)
            protected String value;
            protected String description;

            public DateTimeType getValidFrom() {
                return validFrom;
            }

            public void setValidFrom(final DateTimeType validFrom) {
                this.validFrom = validFrom;
            }

            public DateTimeType getValidTo() {
                return validTo;
            }

            public void setValidTo(final DateTimeType validTo) {
                this.validTo = validTo;
            }

            public String getValue() {
                return value;
            }

            public void setValue(final String value) {
                this.value = value;
            }

            public String getDescription() {
                return description;
            }

            public void setDescription(final String description) {
                this.description = description;
            }
        }

    }


    @XmlAccessorType(XmlAccessType.FIELD)
    @XmlType(name = "", propOrder = {
            "item"
    })
    public static class Violations {

        @XmlElement(required = true)
        protected List<Item> item;


        public List<Item> getItem() {
            if (item == null) {
                item = new ArrayList<Item>();
            }
            return this.item;
        }

        @XmlAccessorType(XmlAccessType.FIELD)
        @XmlType(name = "", propOrder = {

        })
        public static class Item {

            @JsonSerialize(using = DateTimeType.DateTypeSerializer.class)
            @JsonDeserialize(using = DateTimeType.DateTypeDeserializer.class)
            protected DateTimeType validFrom;
            @JsonSerialize(using = DateTimeType.DateTypeSerializer.class)
            @JsonDeserialize(using = DateTimeType.DateTypeDeserializer.class)
            protected DateTimeType validTo;
            @XmlElement(required = true)
            protected String value;
            protected String description;

            public DateTimeType getValidFrom() {
                return validFrom;
            }

            public void setValidFrom(final DateTimeType validFrom) {
                this.validFrom = validFrom;
            }

            public DateTimeType getValidTo() {
                return validTo;
            }

            public void setValidTo(final DateTimeType validTo) {
                this.validTo = validTo;
            }

            public String getValue() {
                return value;
            }

            public void setValue(final String value) {
                this.value = value;
            }

            public String getDescription() {
                return description;
            }

            public void setDescription(final String description) {
                this.description = description;
            }
        }

    }

}
